LeetCode||1.Two Sum

来源:互联网 发布:铁矿石持仓数据 编辑:程序博客网 时间:2024/06/07 15:52

1. Two Sum

  • Total Accepted: 317935
  • Total Submissions: 1163044
  • Difficulty: Easy

Given an array of integers, return indices of the two numbers such that they add up to a specific target.

You may assume that each input would have exactly one solution.

Example:

Given nums = [2, 7, 11, 15], target = 9,Because nums[0] + nums[1] = 2 + 7 = 9,return [0, 1].
看到这题我一开始想用for循环嵌套的,然而,超时了……

O(n^2)的时间复杂度看样子是不被允许的,那只能优化了,然后我找了找其它人的写法,很有意思,用hashtable,我怎么就没想到,Java里面超多API,我竟然没用。

如题,这里只有两个数符合,所以不要想复杂了。

附上代码

import java.util.Hashtable;public class Solution {    public int[] twoSum(int[] nums, int target) {        int a[] = new int[2];Hashtable<Integer, Integer> numbers = new Hashtable<Integer,Integer>();for (int i = 0; i < nums.length; i++) {Integer n = numbers.get(nums[i]);if (n==null) {numbers.put(nums[i], i);}n = numbers.get(target-nums[i]);if (n!=null&&n<i) {a[0]=n;a[1]=i;return a;}}        return a;    }}


0 0
原创粉丝点击